package com.example.qwbweb;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.gson.Gson;
import org.springframework.messaging.support.GenericMessage;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.ResponseBody;

import java.io.ByteArrayInputStream;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

@Controller
public class IndexController {

    public Hashtable system_properties = System.getProperties();

    @PostMapping("/jdk_der")
    @ResponseBody
    public String jdk_der(@RequestBody byte[] input) {
        try {
            ByteArrayInputStream bais = new ByteArrayInputStream(input);
            SafeObjectInputStream ois = new SafeObjectInputStream(bais);
            return (String) system_properties.get((String) ois.readObject());
        } catch (Exception e) {
            e.printStackTrace();
            return "Something error.....";
        }
    }

    @PostMapping("/fastjson_der")
    @ResponseBody
    public String fastjson_der(@RequestBody String input) {

        try {
            JSONObject jsonObject = JSON.parseObject(input);

            String response = "";

            for (Map.Entry entry : jsonObject.entrySet()) {
                String prop = system_properties.get(entry.getValue().toString()).toString();
                response += entry.getValue().toString() + " is " + prop + "; ";
            }

            return response;
        } catch (Exception e) {
            e.printStackTrace();
            return "Something error.....";
        }
    }

    @PostMapping("/gson_der")
    @ResponseBody
    public String gson_der(@RequestBody String input) {
        try {
            Gson gson = new Gson();
            HashMap hashMap = gson.fromJson(input, HashMap.class);

            String response = "";

            Iterator iter = hashMap.entrySet().iterator();
            while (iter.hasNext()) {
                Map.Entry entry = (Map.Entry) iter.next();
                Object key = entry.getKey();
                Object val = entry.getValue();

                String prop = system_properties.get(entry.getValue().toString()).toString();
                response += entry.getValue().toString() + " is " + prop + "; ";
            }

            return response;
        } catch (Exception e) {
            e.printStackTrace();
            return "Something error.....";
        }
    }

    @GetMapping("/get_system_info")
    @ResponseBody
    public String get_system_info(String key) {
        try {
            if (!key.isEmpty() && system_properties.get(key) != null) {
                return system_properties.get(key).toString();
            } else {
                return "null......";
            }
        } catch (Exception e) {
            e.printStackTrace();
            return "Something error.....";
        }
    }


    @GetMapping("/")
    @ResponseBody
    public String get_all_system_info() {
        try {
            return system_properties.toString();

        } catch (Exception e) {
            e.printStackTrace();
            return "Something error.....";
        }
    }

}