package com.example.qwbweb;

import com.sun.org.apache.xalan.internal.xsltc.trax.TemplatesImpl;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.ApplicationRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.DependsOn;
import org.springframework.integration.codec.CodecMessageConverter;
import org.springframework.integration.codec.CompositeCodec;
import org.springframework.integration.codec.kryo.PojoCodec;
import org.springframework.integration.dsl.IntegrationFlow;
import org.springframework.integration.dsl.IntegrationFlows;
import org.springframework.integration.handler.LoggingHandler;
import org.springframework.integration.ip.dsl.Tcp;
import org.springframework.integration.ip.tcp.connection.MessageConvertingTcpMessageMapper;
import org.springframework.integration.ip.tcp.serializer.ByteArrayRawSerializer;
import org.springframework.integration.ip.tcp.serializer.MapJsonSerializer;
import org.springframework.integration.support.converter.MapMessageConverter;
import org.springframework.messaging.handler.annotation.Header;
import org.springframework.util.StringUtils;

import java.util.HashMap;
import java.util.Scanner;

@SpringBootApplication
public class QwbwebApplication {

    public static void main(String[] args) {
        SpringApplication.run(QwbwebApplication.class, args);
    }


    // Common

    @Bean
    public MessageConvertingTcpMessageMapper mapper() {
        PojoCodec pojoCodec = new PojoCodec();
        HashMap hashMap = new HashMap();
        CompositeCodec compositeCodec = new CompositeCodec(hashMap, pojoCodec);
        CodecMessageConverter codecMessageConverter = new CodecMessageConverter(compositeCodec);
        return new MessageConvertingTcpMessageMapper(codecMessageConverter);
    }

    @Bean
    public ByteArrayRawSerializer ByteMapping() {
        return new ByteArrayRawSerializer();
    }

    // Console



}
