package com.example.qwbweb;

import org.springframework.util.ClassUtils;

import java.io.*;
import java.rmi.server.RemoteObject;
import java.util.Arrays;

public class SafeObjectInputStream extends ObjectInputStream {

    public SafeObjectInputStream(InputStream inputStream)
            throws IOException {
        super(inputStream);
    }

    @Override
    protected Class<?> resolveClass(ObjectStreamClass desc) throws IOException,
            ClassNotFoundException {

        String[] black_list = new String[] {
                "java.util.HashMap",
                "com.sun.jndi.rmi.registry.RegistryContext",
                "sun.reflect.annotation.AnnotationInvocationHandler",
                "java.util.PriorityQueue",
                "java.util.HashSet",
                "java.util.Hashtable",
                "org.apache.commons.fileupload.disk.DiskFileItem",
                "org.hibernate.engine.spi.TypedValue",
                "java.util.LinkedHashSet",
                "sun.rmi.server.UnicastRef",
                "java.rmi.server.UnicastRemoteObject",
                "javax.management.openmbean.TabularDataSupport",
                "java.util.Hashtable",
                "org.mozilla.javascript.NativeJavaObject",
                "org.springframework.core.SerializableTypeWrapper",
                "javax.management.BadAttributeValueExpException",
                "org.springframework.beans.factory.ObjectFactory",
                "org.codehaus.groovy.runtime.ConvertedClosure",
                "xalan.internal.xsltc.trax.TemplatesImpl",
                "java.lang.Runtime",
                "java.rmi.server.RemoteObjectInvocationHandler"
        };
        if (Arrays.asList(black_list).contains(desc.getName())) {
            throw new InvalidClassException(
                    "Unauthorized deserialization attempt",
                    desc.getName());
        }
    }
}